package cases

import "spaceofcheng/services/models/model"

// GetTagList 获取标签列表
func (c *CaseController) GetTagList() {
	cases := c.Context.Get("cases").([]model.SysUserCase)
	caseIDs := c.GetCaseIDs(cases)
	page, _ := c.GetInt("page")
	pageSize, _ := c.GetInt("pagesize")

	list, err := c.dao.GetTagList(caseIDs, page, pageSize)
	if err != nil {
		c.ResponseError(err)
	}
	c.ResponseJSON(list)
}

// GetTagByID 根据ID获取标签信息
func (c *CaseController) GetTagByID() {
	tagid := c.GetString(":tagid")
	info, err := c.dao.GetTagByID(tagid)
	if err != nil {
		c.ResponseError(err)
	}
	c.ResponseJSON(list)
}
