package cases

import (
	"jcjy/demo/models"
	"spaceofcheng/services/models/model"
	"strconv"
	"strings"
)

// GetTagCount 获取标签总数
func (m *CaseDAO) GetTagCount(caseids string) (int, error) {
	var tags []model.SysTag
	err := m.db.Where("status=?", models.STATUS_NORMAL).And("case_id in ('" + strings.Replace(caseids, ",", "','", -1) + "')").Find(&tags)
	return len(tags), err
}

// TagInfo 标签
type TagInfo struct {
	model.TaCmsCase `xorm:"extends"`
	CaseNames       string
}

// GetTagList 根据案场获取标签
func (m *CaseDAO) GetTagList(caseids string, page int, pageSize int) ([]TagInfo, error) {
	var tags []TagInfo
	sql := `select tag.*,c.case_names from sys_tag tag inner join (
	select b.tag_id,GROUP_CONCAT(a.case_name) case_names from sys_case a inner join sys_tag_case b on a.case_id=b.case_id and a.status= ` + strconv.Itoa(models.STATUS_NORMAL) + `
	where b.case_id in ('` + strings.Replace(caseids, ",", "','", -1) + `') and b.tag_id not in (select tag_id from sys_tag_case where case_id not in ('` +
		strings.Replace(caseids, ",", "','", -1) + `'))
	group by b.tag_id ) c on tag.tag_id = c.tag_id`

	err := m.db.Sql(sql).Find(tags)
	return tags, err
}

// Tag 标签
type Tag struct {
	model.TaCmsCase `xorm:"extends"`
	TagCases        []model.SysTagCase
}

// GetTagByID 根据ID获取标签
func (m *CaseDAO) GetTagByID(tagid string) (*Tag, error) {
	var tags []Tag
	err := m.db.Table("sys_tag").Where("tag_id=?", tagid).Find(&tags)
	if err != nil {
		return nil, err
	}
	if len(tags) > 0 {
		return &tags[0], err
	}
	return nil, nil
}

// GetTagCaseByTagID 根据标签ID获取标签对应案场
func (m *CaseDAO) GetTagCaseByTagID(tagid string) ([]model.SysTagCase, error) {
	var tagcase []model.SysTagCase
	err := m.db.Where("tag_id=?", tagid).Find(&tagcase)
	return tagcase, err
}
