package cases

import (
	"spaceofcheng/services/models/cases"
	"spaceofcheng/services/service"
)

// GetTagList 获取tag列表
func (s *CaseServ) GetTagList(caseids string, page, pageSize int) (map[string]interface{}, error) {
	if pageSize == 0 {
		pageSize = service.PAGENUM
	}
	tags, err := s.dao.GetTagList(caseids, page, pageSize)
	if err != nil {
		return nil, err
	}
	total, err := s.dao.GetTagCount(caseids)
	if err != nil {
		return nil, err
	}

	return map[string]interface{}{
		"list":     tags,
		"pagesize": pageSize,
		"pagenum":  total,
		"page":     page,
	}, err
}

// GetTagByID 根据ID获取标签
func (s *CaseServ) GetTagByID(tagid string) (*cases.Tag, error) {
	tag, err := s.dao.GetTagByID(tagid)
	if err != nil {
		return nil, err
	}
	if tag != nil {
		tagcases, err := s.dao.GetTagCaseByTagID(tagid)
		if err != nil {
			return nil, err
		}
		tag.TagCases = tagcases
	}
	return tag, err
}
